//
//  Controller.m
//  PHET
//
//  Created by Ian Hooper on 2/08/07.
//  Copyright 2007 __MyCompanyName__. All rights reserved.
//

#import "Controller.h"


@implementation Controller

- (void)awakeFromNib
{
    // set up labjack connection!
    
    long error;
    
    
    // Open first U3 found
    m_localID = -1;
    if ((m_hDevice = openUSBConnection(m_localID)) == NULL)
        return;
    
    
    if (getCalibrationInfo(m_hDevice, &m_caliInfo) < 0)
        return;
}

- (void)dealloc
{
    [self setDigitalOut:0 channel:0];
    [self setDigitalOut:0 channel:1];
    closeUSBConnection(m_hDevice);
}
    
- (double)getAnalogueIn:(int)n
{
    double voltage = 0;
    if (eAIN(m_hDevice, &m_caliInfo, 1, &m_DAC1Enable, n, 31, &voltage, 0, 0, 0, 0, 0, 0) != 0)
        NSLog(@"Error reading analogue input!");
    
    return voltage;
}

- (BOOL)getDigitalIn:(int)channel
{
    long state = 0;
    if (eDI(m_hDevice, 1, channel, &state) != 0)
        NSLog(@"Error reading digital input!");
    
    return state;
}

- (void)setDigitalOut:(BOOL)value channel:(int)n
{
    if (eDO(m_hDevice, 1, n, value) != 0)
        NSLog(@"Error setting digital output!");
}

- (void)setAnalogueOut:(double)value
{
    // DAC0 ONLY!
    if (eDAC(m_hDevice, &m_caliInfo, 0, 0, 2.1, 0, 0, 0) != 0)
        NSLog(@"Error setting DAC0 analogue output!");
}

@end
